/********************************************************************/
/*                                                                  */
/*  PROGRAM....:  WRKPGMFLCL                                        */
/*                                                                  */
/*  TITLE......:  Work with program file levle checks               */
/*                                                                  */
/*  AUTHOR.....:  Mike Faust                                        */
/*                                                                  */
/*  CREATE CMD.:  CRTCLPGM PGM(WRKPGMFLCL)                          */
/*                                                                  */
/********************************************************************/
             PGM        PARM(&PGMLIB &OUTPUT &OUTFILE +
                          &EXCEPT &LIBS)

             DCL        VAR(&PGMLIB) TYPE(*CHAR) LEN(20)
             DCL        VAR(&PGM) TYPE(*CHAR) LEN(10) /* Program +
                          Name */
             DCL        VAR(&LIB) TYPE(*CHAR) LEN(10) /* Program +
                          Library */
             DCL        VAR(&LIBS) TYPE(*CHAR) LEN(252) /* Lib List, +
                          "*LIBL"*/
             DCL        VAR(&OUTFILE) TYPE(*CHAR) LEN(20)
             DCL        VAR(&ERRV) TYPE(*CHAR) LEN(30) VALUE(' ')
             DCL        VAR(&OUTPUT) TYPE(*CHAR) LEN(1)
             DCL        VAR(&OUTF) TYPE(*CHAR) LEN(10) /* Output +
                          File Name */
             DCL        VAR(&OUTL) TYPE(*CHAR) LEN(10) /* Outout +
                          file Library */
             DCL        VAR(&EXCEPT) TYPE(*CHAR) LEN(1) /* +
                          Exceptions Only */
             DCL        VAR(&ERR) TYPE(*CHAR) LEN(1) /* Error Return +
                          Code */

             DCL        VAR(&CTR) TYPE(*DEC) LEN(3 0) VALUE(10)
             DCL        VAR(&LEN) TYPE(*DEC) LEN(3 0) VALUE(10)
             DCL        VAR(&CHAR) TYPE(*CHAR) LEN(1)
             DCL        VAR(&WILDCARD) TYPE(*CHAR) LEN(1)

             CHGVAR &PGM VALUE(%SST(&PGMLIB 1 10))
             CHGVAR &LIB VALUE(%SST(&PGMLIB 11 10))

             IF         COND(%SST(&PGM 1 1) *EQ '*' *AND &PGM *NE +
                          '*ALL      ') THEN(DO)
             SNDPGMMSG  MSG('Invalid Program Name Value Supplied')
             GOTO       CMDLBL(ENDPGM)
             ENDDO
             IF         COND(&PGM *EQ '*ALL      ') THEN(DO)
             CHGVAR     VAR(&WILDCARD) VALUE('1')
             GOTO       CMDLBL(SKIP)
             ENDDO

 LOOP:
             CHGVAR     VAR(&CHAR) VALUE(%SST(&PGM &CTR 1))
             CHGVAR     VAR(&CTR) VALUE(&CTR -1)
             IF         COND(&CHAR *NE ' ') THEN(DO)
             CHGVAR     VAR(&LEN) VALUE(&CTR + 1)
             ENDDO
             ELSE       CMD(DO)
             GOTO       CMDLBL(LOOP)
             ENDDO

             IF         COND(%SST(&PGM &LEN 1) *NE '*' *AND &PGM *NE +
                          '*ALL      ') THEN(DO)
             CHGVAR     VAR(&WILDCARD) VALUE('0')
             CHKOBJ     OBJ(&LIB/&PGM) OBJTYPE(*PGM)
             MONMSG     MSGID(CPF9801 CPF9802 CPF9810 CPF9803) EXEC(DO)
             CHGVAR     VAR(&ERRV) VALUE(&PGM *CAT ' ' *CAT &LIB)
             SNDPGMMSG  MSGID(CPF3033) MSGF(QCPFMSG) MSGDTA(&ERRV)
             GOTO       CMDLBL(ENDPGM)
             ENDDO
             ENDDO
             ELSE       CMD(DO)
             CHGVAR     VAR(&WILDCARD) VALUE('1')
             ENDDO
 SKIP:
             IF         COND(&WILDCARD *EQ '1' *AND &OUTPUT *EQ 'I') +
                          THEN(DO)
             SNDPGMMSG  MSG('Wildcard not allowed when display +
                          output is selected.')
             GOTO       CMDLBL(ENDPGM)
             ENDDO

             IF         COND(&OUTPUT *EQ 'O' *AND &OUTFILE *EQ ' ') +
                          THEN(DO)
             SNDPGMMSG  MSG('When Output type is *OUTFILE an output +
                          file name is required.')
             GOTO       CMDLBL(ENDPGM)
             ENDDO

             IF         COND(&OUTPUT *EQ 'O') THEN(DO)
             CHGVAR &OUTF VALUE(%SST(&OUTFILE 1 10))
             CHGVAR &OUTL VALUE(%SST(&OUTFILE 11 10))
             CHKOBJ     OBJ(&OUTL/&OUTF) OBJTYPE(*FILE)
             MONMSG     MSGID(CPF9810) EXEC(DO)
             CHGVAR     VAR(&ERRV) VALUE(&PGM *CAT ' ' *CAT &LIB)
             SNDPGMMSG  MSGID(CPF9810) MSGF(QCPFMSG) MSGDTA(&ERRV)
             GOTO       CMDLBL(ENDPGM)
             ENDDO
             MONMSG     MSGID(CPF9801) EXEC(DO)
             CRTDUPOBJ  OBJ(WRKPGMFLVP) FROMLIB(*LIBL) OBJTYPE(*FILE) +
                          TOLIB(&OUTL) NEWOBJ(&OUTF)
             ENDDO
             CLRPFM     FILE(&OUTL/&OUTF)
             ENDDO

             DSPPGMREF  PGM(&LIB/&PGM) OUTPUT(*OUTFILE) +
                          OBJTYPE(*ALL) OUTFILE(QTEMP/QADSPPGM)

             OVRDBF     FILE(QADSPPGM) TOFILE(QTEMP/QADSPPGM) +
                          SHARE(*YES)
             OPNQRYF    FILE((QTEMP/QADSPPGM)) QRYSLT('WHOBJT *EQ +
                          "F" *AND WHRFNM *NE " "') KEYFLD((WHFNAM))
             CALL       PGM(BLDFRFCL) PARM(&LIBS)

             OVRDBF     FILE(QAFDRFMT) TOFILE(QTEMP/QAFDRFMT) +
                          SHARE(*YES)

             IF         COND(&OUTPUT *EQ 'O') THEN(DO)
             OVRDBF     FILE(WRKPGMFLVL) TOFILE(&OUTL/&OUTF) +
                          SHARE(*YES)
             ENDDO

             CALL       PGM(WRKPGMFLVL) PARM(&PGM &LIB &OUTPUT +
                          &EXCEPT &ERR)
             IF         COND(&ERR *EQ 'Y') THEN(SNDPGMMSG MSG('Level +
                          Check Errors Found.'))
             DLTOVR     FILE(*ALL)
             CLOF       OPNID(QADSPPGM)
             DLTF       FILE(QTEMP/QADSPPGM)
             DLTF       FILE(QTEMP/QAFDRFMT)

 ENDPGM:     ENDPGM
